/*
**    Copyright (c) 1989 - 2012 (INRIA)
**    Copyright (c) 2011 - 2012 (Scilab Enterprises)
**
**    Generated by Code_Generation toolbox of Xcos with scilab-branch-5.4
**    Date :07-Mar-2013
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

extern void **Cluster_1_block_outtbptr;
extern char input[50],output[50];
FILE *fprr = NULL, *fprw = NULL;
/*----------------------------------------  External events handling function */
void Cluster_1_events(int *nevprt,double *t)
{
}
/*
**    Copyright (c) 1989 - 2012 (INRIA)
**    Copyright (c) 2011 - 2013 (Scilab Enterprises)
**
**    Generated by Code_Generation toolbox of Xcos with scilab-branch-5.4
**    Date : 07-Mar-2013
*/

/* first plot the values inside scilab */
static inline void plot(void) {
    printf("gcf(); drawlater();\n");
    printf("len=size(actuator.values, 'c');\n");
    printf("for i=1:len\n");
    printf("    subplot(len, 1, i);\n");
    printf("    a=gca();\n");
    printf("    a.data_bounds = [actuator.time(1) , -1 ; actuator.time($), 1];\n");
    printf("    c=a.children(1);\n");
    printf("    p=c.children(1);\n");
    printf("    p.data = [actuator.time , actuator.values(:,i)];\n");
    printf("end\n");
    printf("drawnow();\n");
};

/*---------------------------------------- Actuators */
void Cluster_1_actuator(int *flag, int *nport, int *nevprt, double *t, void *u, int *nu1, int *nu2, int *ut, int flag1)
     /*
      * To be customized for standalone execution
      * flag  : specifies the action to be done
      * nport : specifies the  index of the Super Bloc
      *         regular input (The input ports are numbered
      *         from the top to the bottom )
      * nevprt: indicates if an activation had been received
      *         0 = no activation
      *         1 = activation
      * t     : the current time value
      * u     : the vector inputs value
      * nu1   : the input size 1
      * nu2   : the input size 2
      * ut    : the input type
      * flag1 : learn mode (0 from terminal,1 from input file
      */
{
  int j,k,l;
  static int length = 0;

  switch(*flag) {
    case 2:
      if (length >= 1024) {
        plot();

        printf("actuator.time=[];\n");
        printf("actuator.values=[];\n");
        length = 0;
      }

      printf("actuator.time=[actuator.time ; %f];\n", *t);
      
      printf("actuator.values=[actuator.values ; [");
      for (l=0;l<*nu2;l++) {
        for (k=0;k<*nu1;k++) {
          printf("%f ", *((double *) u+(k+l*(*nu1))));
        }
      }
      printf("] ];\n");
      length++;
      break;
    case 4:
      printf("actuator=struct('time', [], 'values', []);\n");
      printf("gcf(); drawlater();\n");
      printf("len=%d;\n", *nu1 * *nu2);
      printf("for i=1:len\n");
      printf("    subplot(len, 1, i);\n");
      printf("    plot2d(0, 0);\n");
      printf("end\n");
      printf("drawnow();\n");
      break;
    case 5:
      plot();
      break;
  }
}
/*---------------------------------------- Sensor */
void Cluster_1_sensor(int *flag, int *nport, int *nevprt, double *t, void *y, int *ny1, int *ny2, int *yt, int *flag1)
     /*
      * To be customized for standalone execution
      * flag  : specifies the action to be done
      * nport : specifies the  index of the Super Bloc
      *         regular input (The input ports are numbered
      *         from the top to the bottom )
      * nevprt: indicates if an activation had been received
      *         0 = no activation
      *         1 = activation
      * t     : the current time value
      * y     : the vector outputs value
      * ny1   : the output size 1
      * ny2   : the output size 2
      * yt    : the output type
      * flag1 : learn mode (0 from terminal,1 from input file
      */
{
  static int counter = 1024;
  static double r = 0;

  switch (*flag) {
    case 1 : /* set the output value */
      if (counter / 1024 > 0) {
        r = (double) rand();
        r = r / RAND_MAX; // r is in range [0.0, 1.0]
      }

      *((double*)y) = sin(2 * 3.1415 * 16000.0 * r * *t);
      break;
    case 4 : /* sensor initialisation */
      break;
    case 5 : /* sensor ending */
      break;
  }
}
